package com.mortals.xhx.module.user.service.impl;
import com.mortals.framework.model.PageInfo;
import com.mortals.framework.util.DataUtil;
import com.mortals.xhx.module.matter.model.MatterDatumEntity;
import com.mortals.xhx.module.matter.model.MatterDatumQuery;
import com.mortals.xhx.module.matter.model.MatterEntity;
import com.mortals.xhx.module.matter.service.MatterDatumService;
import com.mortals.xhx.module.matter.service.MatterService;
import com.mortals.xhx.module.site.model.SiteMatterEntity;
import com.mortals.xhx.module.site.model.SiteMatterQuery;
import com.mortals.xhx.module.site.service.SiteMatterService;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.mortals.framework.service.impl.AbstractCRUDServiceImpl;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.xhx.module.user.dao.UserCollectDao;
import com.mortals.xhx.module.user.model.UserCollectEntity;
import com.mortals.xhx.module.user.service.UserCollectService;

import java.util.List;

/**
* UserCollectService
* 用户收藏夹 service实现
*
* @author zxfei
* @date 2023-03-09
*/
@Service("userCollectService")
public class UserCollectServiceImpl extends AbstractCRUDServiceImpl<UserCollectDao, UserCollectEntity, Long> implements UserCollectService {

    @Autowired
    private MatterDatumService matterDatumService;
    @Autowired
    private SiteMatterService siteMatterService;

    @Override
    protected void findAfter(UserCollectEntity params, PageInfo pageInfo, Context context, List<UserCollectEntity> list) throws AppException {
        for(UserCollectEntity entity:list){
            if(entity.getCollectType()==1) {
                Long matterId = DataUtil.converStr2Long(entity.getBusinessId(), 0l);
                SiteMatterEntity siteMatterEntity = siteMatterService.selectOne(new SiteMatterQuery().matterId(matterId));
                if(siteMatterEntity!=null){
                    entity.setViewsCount(siteMatterEntity.getViewsCount());
                }
                List<MatterDatumEntity> matterDatumFileEntities = matterDatumService.find(new MatterDatumQuery().matterId(matterId));
                if(CollectionUtils.isNotEmpty(matterDatumFileEntities)) {
                    entity.setDatumCount(matterDatumFileEntities.size());
                }else {
                    entity.setDatumCount(0);
                }
            }
        }
    }

    @Override
    protected void findAfter(UserCollectEntity params, Context context, List<UserCollectEntity> list) throws AppException {
        for(UserCollectEntity entity:list){
            if(entity.getCollectType()==1) {
                Long matterId = DataUtil.converStr2Long(entity.getBusinessId(), 0l);
                SiteMatterEntity siteMatterEntity = siteMatterService.selectOne(new SiteMatterQuery().matterId(matterId));
                if(siteMatterEntity!=null){
                    entity.setViewsCount(siteMatterEntity.getViewsCount());
                }
                List<MatterDatumEntity> matterDatumFileEntities = matterDatumService.find(new MatterDatumQuery().matterId(matterId));
                if(CollectionUtils.isNotEmpty(matterDatumFileEntities)) {
                    entity.setDatumCount(matterDatumFileEntities.size());
                }else {
                    entity.setDatumCount(0);
                }
            }
        }
    }
}