package com.mortals.xhx.common.utils;

import com.alibaba.fastjson.JSON;
import com.mortals.framework.common.Rest;
import com.mortals.framework.model.Context;
import com.mortals.xhx.module.base.model.BaseAreaEntity;
import com.mortals.xhx.module.base.service.BaseAreaService;
import com.mortals.xhx.module.dept.service.DeptService;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;

/**
 * 同步区域子数据
 *
 * @author: zxfei
 * @date: 2022/4/13 13:34
 * @description:
 **/
@AllArgsConstructor
@Slf4j
public class SyncSubAreaThread implements Runnable {

    private BaseAreaService baseAreaService;

    private BaseAreaEntity baseAreaEntity;

    private Context context;

    @Override
    public void run() {
        log.info("子区域同步开始！");
        Rest<String> rest = baseAreaService.genSubAreaByRootName(baseAreaEntity, context);
        log.info("子区域同步结束！结果:{}", JSON.toJSONString(rest));
    }

}
